/*
hupdt.c Version 0.1.0  Hash update record
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* return code 0 is good update */
/* return code 1 is record not found */
/* return code 3 is lock pending prior to update */
/* return code 4 is lock error */

#include <bthash.h>

int hupdt(hashfmt *hshhdr, unsigned char *rcd)
   {
   long ofst;
   int hgrslt;
   int sigrslt;
   unsigned char *p,*q,*r;
   unsigned char *buf;
   hshhdr->reason = 0;
   sigrslt = strcmp(hshhdr->signature,H_SIGNATURE);
   if (sigrslt)
      {
      fprintf(stderr,"hdlet: non-hash "
         "update\n");
      hshhdr->reason = HASH_ERR + 2203;
      return(HASH_ERR + 2203);
      } /* if non-hash delete */
   buf = (unsigned char *) malloc(hshhdr->rcdlen + 16);
   if (buf == NULL)
      {
      fprintf(stderr,"hupdt: out of memory\n");
      return(HASH_ERR + 2201);
      } /* out of mem */
   p = (unsigned char *) rcd + hshhdr->keyofst;
   hgrslt = hget(hshhdr,p,buf);
   free(buf);
   if (hgrslt) return(hgrslt);
   p = (unsigned char *)
      hshhdr->node + hshhdr->rcdhdr;
   q = (unsigned char *) p + hshhdr->rcdlen;
   r = (unsigned char *) rcd;
   while (p < q) *p++ = *r++;
   ofst = (long) hshhdr->ofst;
   hputblk(hshhdr,ofst,hshhdr->node);
   if (hshhdr->reason) return(HASH_ERR + 2202);
   p = (unsigned char *) hshhdr->node;
   q = (unsigned char *) hshhdr->node + hshhdr->rcdnode;
   while (p < q) *p++ = '\0';
   hshhdr->ofst = (long) 0;
   return(UPDTGOOD);
   } /* hupdt */
